Release new version 0.17.1
[grml-hwinfo.git] / grml-hwinfo
index f0bd2a9..97ad572 100755 (executable)
@@ -23,13 +23,13 @@ export LC_ALL=C
 TIMESTAMP='+%F--%H-%M-%S-%Z'
 DATE="$(date $TIMESTAMP)"
 
-echo "$PN ${VERSION} - collect hardware information"
-
 # defaults
 GENERATE_FILE='1'
 GENERATE_DIRECTORY=''
 _opt_output_directory=false
 _opt_output_file=false
+_opt_quiet=false
+_opt_force=false
 
 usage() {
   echo "
@@ -45,13 +45,15 @@ usage() {
   -d, --directory            Create grml-hwinfo-TIMESTAMP as a directory (no file)
   -f, --file                 Create grml-hwinfo-TIMESTAMP.tar.bz2 [default action]
   -h, --help                 Display this help message
+  -q, --quiet                Don't display informational text (useful for cron usage)
+  --force                    Don't abort but overwrite possibly existing output file
   --output-directory <dir>   Store output files in specified directory
-  --output-file <file>       Store output in specified filename (tar.bz2 format)
+  --output-file <file>       Store output in specified filename (tar.XX format)
   "
 }
 
-CMDLINE_OPTS=output-directory:,output-file:,both,directory,file,help
-_opt_temp=$(getopt --name grml-hwinfo -o +bdfh --long $CMDLINE_OPTS -- "$@")
+CMDLINE_OPTS=output-directory:,output-file:,both,directory,file,help,quiet,force
+_opt_temp=$(getopt --name grml-hwinfo -o +bdfhq --long $CMDLINE_OPTS -- "$@")
 if [ $? -ne 0 ]; then
   echo "Try 'grml-hwinfo --help' for more information." >&2
   exit 1
@@ -87,6 +89,12 @@ while :; do
     GENERATE_DIRECTORY='1'
     GENERATE_FILE='1'
     ;;
+  -q|--quiet)
+    _opt_quiet=true
+    ;;
+  --force)
+    _opt_force=true
+    ;;
   --)
     shift; break
     ;;
@@ -98,21 +106,36 @@ while :; do
   shift
 done
 
+if ! $_opt_quiet ; then
+  echo "$PN ${VERSION} - collect hardware information"
+fi
+
 # Generate output/temporary directory name & path, and output file path
 [ -n "$OUTDIRNAME" ] || OUTDIRNAME="grml-hwinfo-${DATE}"
-OUTDIR="${WORKING_DIR}/${OUTDIRNAME}"
-mkdir "${OUTDIR}" || { echo "Directory '${OUTDIR}' already exists, aborting." >&2 ; exit 1; }
+if $_opt_output_directory ; then
+  OUTDIR="${OUTDIRNAME}"
+else
+  OUTDIR="${WORKING_DIR}/${OUTDIRNAME}"
+fi
+
+if $_opt_force ; then
+  mkdir -p "${OUTDIR}"
+else
+  mkdir "${OUTDIR}" || { echo "Directory '${OUTDIR}' already exists, aborting." >&2 ; exit 1; }
+fi
 
 if [ -n "$GENERATE_FILE" ] ; then
   [ -n "$OUTFILE" ] && OUTFILE_="$OUTFILE" || OUTFILE_="${OUTDIR}.tar.bz2"
-  [ -e "${OUTFILE_}" ] && { echo "File '${OUTFILE_}' already exists, aborting." >&2 ; rm -r "${OUTDIR}"; exit 1; }
+  if ! $_opt_force ; then
+    [ -e "${OUTFILE_}" ] && { echo "File '${OUTFILE_}' already exists, aborting." >&2 ; rm -r "${OUTDIR}"; exit 1; }
+  fi
   OUTFILE=${OUTFILE_}
   touch "${OUTFILE}"
 fi
 
 if [ "$(id -u)" != "0" ] ; then
   NOTROOT=1
-  echo "W: Running without root permissions. Not all data will be collected."
+  $_opt_quiet || echo "W: Running without root permissions. Not all data will be collected."
 fi
 
 # check whether a binary is available and executable
@@ -124,51 +147,55 @@ exectest() {
     if test -e "$(which "$1")" ; then
       return 0
     else
-      grep -q "^$1"'$' missing_tools 2>/dev/null || echo "$1" >> missing_tools
+      if ! grep -q "^$1"'$' missing_tools 2>/dev/null ; then
+        $_opt_quiet || echo "$1" >> missing_tools
+      fi
       return 1
     fi
   fi
 }
 
-# echo a list of all disks and their size
-# taken from http://cvs.debian.org/fai/lib/disk-info
-diskandsize() {
-  local isdisk major minor blocks device suffix
-  while read _ _ blocks device _ ; do
-    isdisk=1
-    # skip ide cdrom
-    [ -f "/proc/ide/${device}/media" ] && grep -q cdrom "/proc/ide/${device}/media" && isdisk=0
-    [ "$isdisk" -eq 1 ] && echo "$device $blocks"
-  done
+disk_info() {
+  # the variable holds a newline separated list of disk block devices, excluding loopback and CD-ROM devices
+  disklist=$(lsblk -nd -o NAME -e 7,11)
 }
 
-list_disks() {
-  # print only every second entry; used by disk_info
-  i=0
-  for ent in "$@" ; do
-    if [ "$i" -eq 0 ]; then
-      echo "$ent"
-      i=1
-    else
-      i=0
-    fi
+# return list of all network devices in array "${niclist[@]}"
+get_network_devices() {
+  local interface
+  niclist=()
+  for interface in /sys/class/net/* ; do
+      [ -e "${interface}" ] || continue
+      interface=$(basename "${interface}")
+      # [ "${interface}" = "lo" ] && continue
+      niclist+=("${interface}")
   done
 }
 
-disk_info() {
-  # the variable holds a space separated list of devices and their block size
-  device_size=$(grep -E ' cciss/c.d.$| ida/c.d.$| rd/c.d.$| hd.$| sd.$|/disc$' /proc/partitions | diskandsize)
-  # a list of all local disks, without size
-  disklist=$(list_disks "$device_size")
-}
+# Check if X server is running
+#
+# If xset is missing, we rely on the existence of the $DISPLAY variable.
+NO_DISPLAY=0
+if exectest xset ; then
+  if ! timeout 1s xset q &>/dev/null ; then
+    NO_DISPLAY=1
+  fi
+elif [ -z "${DISPLAY}" ] ; then
+    NO_DISPLAY=1
+fi
 
+if [ "${NO_DISPLAY}" -eq 1 ] ; then
+  $_opt_quiet || echo "W: Running without X server. Not all data will be collected."
+fi
 
 cd "${OUTDIR}" || exit 1
 (
-  [ -n "$GENERATE_FILE" ]      && echo "Output file:      $OUTFILE"
-  [ -n "$GENERATE_DIRECTORY" ] && echo "Output directory: $OUTDIR"
-  echo
-  echo "This might take a few seconds/minutes. Please be patient..."
+  if ! $_opt_quiet ; then
+    [ -n "$GENERATE_FILE" ]      && echo "Output file:      $OUTFILE"
+    [ -n "$GENERATE_DIRECTORY" ] && echo "Output directory: $OUTDIR"
+    echo
+    echo "This might take a few seconds/minutes. Please be patient..."
+  fi
 
   # some sysinfo
   date > ./date
@@ -180,52 +207,98 @@ cd "${OUTDIR}" || exit 1
   fi
   uname -a > ./uname
 
+  # inxi
+  exectest inxi  && inxi -F -xx > ./inxi 2>./inxi.error
+  exectest inxi  && inxi -FJ --admin > ./inxi_admin 2>./inxi_admin.error
+
   # disks / devices
   [ -f /proc/scsi/scsi ] && cat /proc/scsi/scsi > scsi
   exectest lspci && lspci -nn > ./lspci
+  exectest lspci && lspci -vvnn > ./lspci_verbose
   cat /proc/partitions > partitions
   find /proc/ide/ -name geometry -exec grep . {} \; > proc_ide 2>/dev/null
   df -h > ./df 2>/dev/null
-  for i in free lsmod mount lsdev lspnp lsusb ; do
+  for i in free lsmod mount lsdev lspnp ; do
     exectest $i && $i > ./$i
   done
+
+  if exectest lsusb ; then
+    lsusb    > ./lsusb
+    lsusb -v > ./lsusb_verbose 2>./lsusb_verbose.error
+  fi
+
   swapon -s > ./swapon 2>./swapon.error
 
   # proc stuff
   for i in cpuinfo interrupts cmdline devices dma fb iomem ioports \
-    mdstat meminfo modules mtrr pci version ; do
+    mdstat meminfo modules mtrr pci uptime version ; do
     [ -r /proc/$i ] && cat /proc/$i > proc_$i
   done
+
+  if ! $_opt_quiet ; then
+    echo "Starting sysdump..."
+    echo "  NOTE: if it seems to be hanging at this stage file a bug report with output of:"
+    echo "        lsof -p \$(pgrep -f "\$\(which sysdump\)")"
+  fi
   exectest sysdump  && sysdump > ./sysdump 2>./sysdump.error
+  if ! $_opt_quiet ; then
+    echo "Execution of sysdump finished."
+  fi
+
+  exectest cpuid && cpuid > ./cpuid 2>./cpuid.error
+
+  exectest uptime && uptime > ./uptime 2>./uptime.error
 
   # log
   dmesg > dmesg.cur
 
   # hwinfo
-  exectest discover && discover -v --type-summary --enable-bus all > ./discover 2>./discover.2
+  exectest discover && discover -v --type-summary --enable-bus all > ./discover 2>./discover.error
   exectest hwinfo   && hwinfo log=hwinfo
   exectest numactl  && numactl --hardware > ./numactl
-  exectest x86info  && x86info > ./x86info 2>./x86info.2
+  exectest x86info  && x86info > ./x86info 2>./x86info.error
   exectest lscpu    && lscpu > ./lscpu
+  exectest lscpu    && lscpu -e > ./lscpu_extended
+
+  # EFI
+  exectest efibootmgr && efibootmgr -v >efibootmgr 2>efibootmgr.error
 
   # net stuff, net-tools:
   exectest ifconfig && ifconfig -v -a > ./ifconfig
   exectest route    && route -n       > ./route
 
+  # net stuff, ethtool
+  if exectest ethtool ; then
+    get_network_devices
+    for dev in "${niclist[@]}" ; do
+      ethtool          "${dev}" > ethtool_"${dev}"
+      case "${dev}" in
+        "lo")
+          # skip the loopback device, `ethtool --driver lo` fails with:
+          # "Cannot get driver information: Operation not supported"
+          ;;
+        *)
+          ethtool --driver "${dev}" > ethtool_"${dev}_driver"
+          ;;
+      esac
+    done
+  fi
+
   # net stuff, iproute:
   exectest ip && ip addrlabel list > ip_addrlabel
   exectest ip && ip addr show      > ip_addr
   exectest ip && ip link show      > ip_link
   exectest ip && ip maddr show     > ip_maddr
   exectest ip && ip mroute show    > ip_mroute
-  exectest ip && ip mrule show     > ip_mrule
+  exectest ip && ip mrule show     > ip_mrule 2>ip_mrule.error
   exectest ip && ip neigh show     > ip_neigh
+  exectest ip && ip netconf        > ip_netconf
   exectest ip && ip netns list     > ip_netns
   exectest ip && ip ntable show    > ip_ntable
   exectest ip && ip route show     > ip_route
   exectest ip && if [ -r /etc/iproute2/rt_tables ] ; then
                    grep -v '^#' /etc/iproute2/rt_tables | while read table _ ; do
-                     ip route show table "${table}" > "ip_route_table_${table}"
+                     ip route show table "${table}" > "ip_route_table_${table}" 2> "ip_route_table_${table}".error
                    done
                  fi
   exectest ip && ip rule show      > ip_rule
@@ -244,7 +317,11 @@ cd "${OUTDIR}" || exit 1
     cat /proc/acpi/info > acpi_info
   fi
 
-  exectest acpi && acpi > ./acpi 2>acpi.error && acpi -v > ./acpi.version
+  if exectest acpi ; then
+    acpi > ./acpi 2>acpi.error
+    acpi --everything > ./acpi.everything 2>./acpi.everything.error
+    acpi -v > ./acpi.version
+  fi
   [ -r /proc/apm/ ] && apm > ./apm
 
   if exectest mcelog ; then
@@ -263,7 +340,7 @@ cd "${OUTDIR}" || exit 1
   dpkg -S "/boot/vmlinuz-$(uname -r)" >> running_kernel 2>>running_kernel.error
 
   # X stuff
-  if [ -n "${DISPLAY}" ] ; then
+  if [ "${NO_DISPLAY}" -eq 0 ] ; then
     exectest xviddetect  && xviddetect         > ./xviddetect
     exectest xvidtune    && xvidtune -show     > ./xdivtune
     exectest xrandr      && xrandr             > ./xrandr
@@ -275,6 +352,10 @@ cd "${OUTDIR}" || exit 1
     cp /var/log/$i log_$i 2>/dev/null
   done
 
+  if [ -r "$HOME"/.local/share/xorg/Xorg.0.log ] ; then
+    cp "$HOME"/.local/share/xorg/Xorg.0.log user_Xorg.0.log
+  fi
+
   cp /etc/X11/xorg.conf    xorg.conf    2>/dev/null
   cp /etc/modules          modules      2>/dev/null
   cp /etc/X11/XF86Config-4 XF86Config-4 2>/dev/null
@@ -285,10 +366,8 @@ cd "${OUTDIR}" || exit 1
   else
     echo "running as root" > root
     disk_info
-    exectest sfdisk     && sfdisk -d > ./sfdisk 2>./sfdisk.error
-    exectest dmidecode  && dmidecode > ./dmidecode
 
-    exectest dconf && dconf -o dconf
+    exectest dmidecode  && dmidecode > ./dmidecode
 
     if exectest mcelog ; then
       mcelog --dmi > mcelog_dmi 2>mcelog_dmi.error
@@ -305,6 +384,14 @@ cd "${OUTDIR}" || exit 1
       /usr/share/doc/lm-sensors/examples/eeprom/decode-dimms.pl > decode-dimms 2>decode-dimms.error
     fi
 
+    if exectest acpidump ; then
+      acpidump > ./acpidump 2>./acpidump.error
+    fi
+
+    if exectest mokutil ; then
+      mokutil --sb-state > ./mokutil_state 2>./mokutil_state.error
+    fi
+
     # proxmox
     exectest qm && qm list > ./qm 2>./qm.error
     # libvirt
@@ -342,6 +429,10 @@ cd "${OUTDIR}" || exit 1
     fi
 
     for disk in $disklist; do
+      if exectest sfdisk && [[ -b "/dev/${disk}" ]] ; then
+        sfdisk -d "/dev/${disk}" > "./sfdisk_${disk}" 2>"./sfdisk_${disk}.error"
+      fi
+
       if exectest smartctl ; then
         echo -e "smartctl -a /dev/${disk}:\n" >> smartctl
         smartctl -a "/dev/$disk" >> ./smartctl
@@ -350,7 +441,7 @@ cd "${OUTDIR}" || exit 1
 
       if exectest hdparm ; then
         echo -e "hdparm -iv /dev/${disk}:\n" >> hdparm
-        hdparm -iv "/dev/$disk" >> ./hdparm
+        hdparm -iv "/dev/$disk" >> ./hdparm 2>> ./hdparm.error
         echo -e "\n\n" >> hdparm
       fi
 
@@ -374,7 +465,7 @@ cd "${OUTDIR}" || exit 1
 
       if exectest sg_inq ; then
         echo -e "sg_inq /dev/${disk}:\n" >> sg_inq
-        sg_inq "/dev/$disk" >> ./sg_inq
+        sg_inq "/dev/$disk" >> ./sg_inq 2>> ./sg_inq.error
         echo -e "\n\n" >> sg_inq
       fi
 
@@ -388,15 +479,17 @@ for file in *.error ; do
   test -s "$file" || rm -- "$file"
 done
 
-echo
+$_opt_quiet || echo
 
 cd "${WORKING_DIR}"
 
 # create tarball
 if [ -n "$GENERATE_FILE" ] ; then
   tar acf "${OUTFILE}" "${OUTDIRNAME}"
-  # shellcheck disable=SC2012
-  [ -r "$OUTFILE" ] && echo "$OUTFILE ($(ls -ahl -- "$OUTFILE" | awk '{print $5}')) has been generated."
+  if ! $_opt_quiet ; then
+    # shellcheck disable=SC2012
+    [ -r "$OUTFILE" ] && echo "$OUTFILE ($(ls -ahl -- "$OUTFILE" | awk '{print $5}')) has been generated."
+  fi
 fi
 
 # remove (temporary) output directory if needed, else keep it, as it doubles
@@ -404,7 +497,9 @@ fi
 if [ -z "$GENERATE_DIRECTORY" ] ; then
   rm -r "${OUTDIR}"
 else
-  [ -r "${OUTDIR}" ] && echo "${OUTDIR} has been generated."
+  if ! $_opt_quiet ; then
+    [ -r "${OUTDIR}" ] && echo "${OUTDIR} has been generated."
+  fi
 fi
 
 exit 0